;#AutoIt3Wrapper_au3check_parameters=-d -w 1 -w 2 -w 3 -w 4 -w 5 -w 6
#AutoIt3Wrapper_UseX64=n
#include "Bass.au3"
#include "BassExt.au3"
#include <GDIPlus.au3>
#include <WindowsConstants.au3>
#include <GUIConstantsEx.au3>

Global $iWidth = 780
Global $iHeight = 560


Global $iPK_Cnt_TH = 50
Global $iVU_Cnt_TH = 25
Global $nPeak_TH = 0.99

Global $hGui, $sFile, $hStream, $tPeak, $hDspLevel
Global $iLong, $iLevel, $ndB, $nLevel_VU_L, $nLevel_VU_R, $nLevel_PK_L, $nLevel_PK_R
Global $nLevel_MVU_L, $nLevel_MVU_R, $nLevel_MPK_L, $nLevel_MPK_R, $iPK_Cnt_L, $iPK_Cnt_R, $iVU_Cnt_L, $iVU_Cnt_R
Global $iPeak_L, $iPeak_R
Global $nPhase
Global $hGraphics, $hBmpBuffer, $hGfxBuffer, $hBmpMeter, $hBmpLed, $hBmpBk
Global $iTimer

Opt("GUIOnEventMode", 1)

$sFile = FileOpenDialog("Open...", "", "Mp3 Files (*.mp3)|Wav Files (*.wav)")
___Debug($sFile = "", $sFile)

$hGui = GUICreate("Audio Meter by Eukalyptus", $iWidth, $iHeight)
GUISetOnEvent(-3, "_EXIT")
GUISetState()

_GDIPlus_Startup()
$hGraphics = _GDIPlus_GraphicsCreateFromHWND($hGui)
$hBmpBuffer = _GDIPlus_BitmapCreateFromGraphics($iWidth, $iHeight, $hGraphics)
$hGfxBuffer = _GDIPlus_ImageGetGraphicsContext($hBmpBuffer)
_GDIPlus_GraphicsSetSmoothingMode($hGfxBuffer,2)
$hBmpMeter = _CreateMeterBmp($hGraphics, 15, 500)
$hBmpPhase = _CreatePhaseBmp($hGraphics, 500, 45)
$hBmpLed = _CreateLedBmp($hGraphics, 15, 0xFF000000, 0xFFFF1111)
$hBmpBk = _CreateBkBmp($iWidth, $iHeight, $hGraphics)
$hPenPhase = _GDIPlus_PenCreate(0xFFDDDDFF, 2)

_BASS_Startup(@ScriptDir & "\bass.dll")
___Debug(@error, "load bass.dll")

_BASS_EXT_Startup(@ScriptDir & "\bassExt.dll")
___Debug(@error, "load bassext.dll")

_BASS_Init(0, -1, 44100, 0, "")
___Debug(@error, "initialize bass")

_BASS_SetConfig($BASS_CONFIG_UPDATEPERIOD, 50)
___Debug(@error, "set update period")

_BASS_SetConfig($BASS_CONFIG_BUFFER, 100)
___Debug(@error, "set buffer size")


$hStream = _BASS_StreamCreateFile(False, $sFile, 0, 0, $BASS_SAMPLE_FLOAT)
___Debug(@error, "create stream from file")

$tPeak = DllStructCreate($BASS_EXT_StructPeak)
$hDspLevel = _BASS_ChannelSetDSP($hStream, $BASS_EXT_DspPeakProc, DllStructGetPtr($tPeak), 10)
___Debug(@error, "sets a DSP-callback on the stream to look for level peaks")

_BASS_ChannelPlay($hStream, True)
___Debug(@error, "Start playing stream")

$iTimer = TimerInit()
GUIRegisterMsg($WM_PAINT, "WM_PAINT")
GUIRegisterMsg($WM_ERASEBKGND, "WM_ERASEBKGND")
While _BASS_ChannelIsActive($hStream)
	If TimerDiff($iTimer) > 20 Then
		;ConsoleWrite(TimerDiff($iTimer) & @CRLF)
		$iTimer = TimerInit()
		_GDIPlus_GraphicsDrawImage($hGfxBuffer, $hBmpBk, 0, 0)
		_Meter()
		_Phase()

		_GDIPlus_GraphicsDrawImage($hGraphics, $hBmpBuffer, 0, 0)
	EndIf
WEnd

_Exit()


Func WM_PAINT($hWnd, $uMsgm, $wParam, $lParam)
	_GDIPlus_GraphicsDrawImage($hGraphics, $hBmpBuffer, 0, 0)
	Return $GUI_RUNDEFMSG
EndFunc   ;==>WM_PAINT

Func WM_ERASEBKGND($hWnd, $uMsgm, $wParam, $lParam)
	_GDIPlus_GraphicsDrawImage($hGraphics, $hBmpBuffer, 0, 0)
	Return True
EndFunc   ;==>WM_ERASEBKGND


Func _Phase()
	Local $aPhase = _BASS_EXT_ChannelGetPhaseData($hStream, 512)
	For $i = 1 To $aPhase[0][0]
		$aPhase[$i][0] = 500 + 250 * $aPhase[$i][0]
		$aPhase[$i][1] = 220 + 200 * $aPhase[$i][1]
	Next
	_GDIPlus_GraphicsDrawClosedCurve($hGfxBuffer, $aPhase, $hPenPhase)
	$nPhase += ($aPhase[0][1] - $nPhase) / 12
	Local $iPhase = 249 * $nPhase + 250
	$iPhase -= Mod($iPhase, 4)
	_GDIPlus_GraphicsDrawImageRectRect($hGfxBuffer, $hBmpPhase, $iPhase, 0, 4, 45, 250 + $iPhase, 460, 4, 45)
EndFunc   ;==>_Phase



Func _Meter()
	$iLong = _BASS_ChannelGetLevel($hStream)
	$ndB = _BASS_EXT_Level2dB(_WinAPI_LoWord($iLong) / 32768, 60)
	If $ndB > $nLevel_PK_L Then $nLevel_PK_L = $ndB
	If $ndB >= $nLevel_MPK_L - 0.01 Then
		$nLevel_MPK_L = $ndB
		$iPK_Cnt_L = 0
	EndIf
	$iLevel = Round(500 * $nLevel_PK_L)
	$iLevel -= Mod($iLevel, 4)
	_GDIPlus_GraphicsDrawImageRectRect($hGfxBuffer, $hBmpMeter, 0, 500 - $iLevel, 15, $iLevel, 20, 540 - $iLevel, 15, $iLevel)

	$ndB = _BASS_EXT_Level2dB(_WinAPI_HiWord($iLong) / 32768, 60)
	If $ndB > $nLevel_PK_R Then $nLevel_PK_R = $ndB
	If $ndB >= $nLevel_MPK_R - 0.01 Then
		$nLevel_MPK_R = $ndB
		$iPK_Cnt_R = 0
	EndIf
	$iLevel = Round(500 * $nLevel_PK_R)
	$iLevel -= Mod($iLevel, 4)
	_GDIPlus_GraphicsDrawImageRectRect($hGfxBuffer, $hBmpMeter, 0, 500 - $iLevel, 15, $iLevel, 120, 540 - $iLevel, 15, $iLevel)

	$iLong = _BASS_EXT_ChannelGetRMSLevel($hStream)
	$ndB = _BASS_EXT_Level2dB(_WinAPI_LoWord($iLong) / 32768, 60)
	If $ndB > $nLevel_VU_L Then $nLevel_VU_L = $ndB
	If $ndB >= $nLevel_MVU_L - 0.01 Then
		$nLevel_MVU_L = $ndB
		$iVU_Cnt_L = 0
	EndIf
	$iLevel = Round(500 * $nLevel_VU_L)
	$iLevel -= Mod($iLevel, 4)
	_GDIPlus_GraphicsDrawImageRectRect($hGfxBuffer, $hBmpMeter, 0, 500 - $iLevel, 15, $iLevel, 40, 540 - $iLevel, 45, $iLevel)

	$ndB = _BASS_EXT_Level2dB(_WinAPI_HiWord($iLong) / 32768, 60)
	If $ndB > $nLevel_VU_R Then $nLevel_VU_R = $ndB
	If $ndB >= $nLevel_MVU_R - 0.01 Then
		$nLevel_MVU_R = $ndB
		$iVU_Cnt_R = 0
	EndIf
	$iLevel = Round(500 * $nLevel_VU_R)
	$iLevel -= Mod($iLevel, 4)
	_GDIPlus_GraphicsDrawImageRectRect($hGfxBuffer, $hBmpMeter, 0, 500 - $iLevel, 15, $iLevel, 140, 540 - $iLevel, 45, $iLevel)

	$iLevel = Round(500 * $nLevel_MPK_L)
	$iLevel -= Mod($iLevel, 4)
	_GDIPlus_GraphicsDrawImageRectRect($hGfxBuffer, $hBmpMeter, 0, 500 - $iLevel, 15, 4, 20, 540 - $iLevel, 15, 4)

	$iLevel = Round(500 * $nLevel_MPK_R)
	$iLevel -= Mod($iLevel, 4)
	_GDIPlus_GraphicsDrawImageRectRect($hGfxBuffer, $hBmpMeter, 0, 500 - $iLevel, 15, 4, 120, 540 - $iLevel, 15, 4)

	$iLevel = Round(500 * $nLevel_MVU_L)
	$iLevel -= Mod($iLevel, 4)
	_GDIPlus_GraphicsDrawImageRectRect($hGfxBuffer, $hBmpMeter, 0, 500 - $iLevel, 15, 4, 40, 540 - $iLevel, 45, 4)

	$iLevel = Round(500 * $nLevel_MVU_R)
	$iLevel -= Mod($iLevel, 4)
	_GDIPlus_GraphicsDrawImageRectRect($hGfxBuffer, $hBmpMeter, 0, 500 - $iLevel, 15, 4, 140, 540 - $iLevel, 45, 4)


	If DllStructGetData($tPeak, 1) >= $nPeak_TH Then $iPeak_L = $iPK_Cnt_TH * 3
	If DllStructGetData($tPeak, 2) >= $nPeak_TH Then $iPeak_R = $iPK_Cnt_TH * 3
	_BASS_EXT_ResetPeakLevel($tPeak)

	If $iPeak_L > $iPK_Cnt_TH Then _GDIPlus_GraphicsDrawImage($hGfxBuffer, $hBmpLed, 20, 20)
	If $iPeak_R > $iPK_Cnt_TH Then _GDIPlus_GraphicsDrawImage($hGfxBuffer, $hBmpLed, 120, 20)

	$nLevel_VU_L -= 0.01
	$nLevel_VU_R -= 0.01
	$nLevel_PK_L -= 0.01
	$nLevel_PK_R -= 0.01
	$iVU_Cnt_L += 1
	$iVU_Cnt_R += 1
	If $iVU_Cnt_L > $iVU_Cnt_TH Then $nLevel_MVU_L -= 0.0025
	If $iVU_Cnt_R > $iVU_Cnt_TH Then $nLevel_MVU_R -= 0.0025
	$iPK_Cnt_L += 1
	$iPK_Cnt_R += 1
	If $iPK_Cnt_L > $iPK_Cnt_TH Then $nLevel_MPK_L -= 0.0025
	If $iPK_Cnt_R > $iPK_Cnt_TH Then $nLevel_MPK_R -= 0.0025
	$iPeak_L -= 1
	If $iPeak_L < 0 Then $iPeak_L = 0
	$iPeak_R -= 1
	If $iPeak_R < 0 Then $iPeak_R = 0
EndFunc   ;==>_Meter









Func _CreateBkBmp($iW, $iH, $hGraphics)
	Local $hBitmap = _GDIPlus_BitmapCreateFromGraphics($iW, $iH, $hGraphics)
	Local $hContext = _GDIPlus_ImageGetGraphicsContext($hBitmap)
	_GDIPlus_GraphicsSetSmoothingMode($hContext,2)
	Local $hBrush = _GDIPlus_BrushCreateSolid(0xE0000000)
	Local $hBrush_TXT = _GDIPlus_BrushCreateSolid(0xFFFFFFFF)
	Local $hPen = _GDIPlus_PenCreate(0xFFFFFFFF)
	_GDIPlus_GraphicsClear($hContext, 0xFF000000)
	_GDIPlus_GraphicsDrawImage($hContext, $hBmpMeter, 20, 40)
	_GDIPlus_GraphicsDrawImage($hContext, $hBmpMeter, 120, 40)
	_GDIPlus_GraphicsDrawImageRect($hContext, $hBmpMeter, 40, 40, 45, 500)
	_GDIPlus_GraphicsDrawImageRect($hContext, $hBmpMeter, 140, 40, 45, 500)
	_GDIPlus_GraphicsDrawImage($hContext, $hBmpLed, 20, 20)
	_GDIPlus_GraphicsDrawImage($hContext, $hBmpLed, 120, 20)

	_DrawText($hContext, "PEAK", 40, 20, 10, $hBrush_TXT)
	_DrawText($hContext, "PEAK", 140, 20, 10, $hBrush_TXT)

	Local $sString
	Local $nY
	For $i = 0 To 59 Step 3
		$nY = _BASS_EXT_Level2dB(_BASS_EXT_dB2Level(-$i), 60)
		$sString = "-" & $i
		If $i = 0 Then $sString = "0 dB"
		_DrawText($hContext, $sString, 85, 540 - (500 * $nY), 10, $hBrush_TXT)
		_DrawText($hContext, $sString, 185, 540 - (500 * $nY), 10, $hBrush_TXT)
	Next

	_GDIPlus_GraphicsDrawImage($hContext, $hBmpPhase, 250, 460)
	For $i = -1 To 1 Step 0.5
		_DrawText($hContext, $i, 500 + 250 * $i, 440, 10, $hBrush_TXT, True)
		_DrawText($hContext, (-$i) * 90 + 90, 500 + 250 * $i, 510, 10, $hBrush_TXT, True)
	Next
	;500+250
	;220+200
	Local $iLX, $iLY, $iRX = 250 * 0.7, $iRY = 200 * 0.7
	Local $pi = 3.14159265358979
	Local $radToDeg = 180 / $pi
	Local $degToRad = $pi / 180
	For $i = 0 To 270 Step 45
		$iLX = Round(Cos($i * $degToRad) * $iRX)
		$iLY = Round(Sin($i * $degToRad) * $iRY)
		_GDIPlus_GraphicsDrawLine($hContext, 500 - $iLX, 220 - $iLY, 500 + $iLX, 220 + $iLY, $hPen)
		Switch $i
			Case 45
				_DrawText($hContext, "L", 500 - $iLX * 1.2, 220 - $iLY * 1.4, 20, $hBrush_TXT, True)
			Case 90
				_DrawText($hContext, "M", 500 - $iLX * 1.3, 220 - $iLY * 1.3, 20, $hBrush_TXT, True)
			Case 135
				_DrawText($hContext, "R", 500 - $iLX * 1.2, 220 - $iLY * 1.4, 20, $hBrush_TXT, True)
		EndSwitch
	Next

	_GDIPlus_GraphicsFillRect($hContext, 0, 0, $iW, $iH, $hBrush)
	_GDIPlus_BrushDispose($hBrush)
	_GDIPlus_GraphicsDispose($hContext)
	Return $hBitmap
EndFunc   ;==>_CreateBkBmp


Func _DrawText($hGraphics, $sText, $iX, $iY, $iSize, $hBrush, $bCenter = False)
	Local $hFormat = _GDIPlus_StringFormatCreate()
	Local $hFamily = _GDIPlus_FontFamilyCreate("Arial")
	Local $hFont = _GDIPlus_FontCreate($hFamily, $iSize, 0)
	Local $tLayout = _GDIPlus_RectFCreate($iX, $iY, 0, 0)
	Local $aInfo = _GDIPlus_GraphicsMeasureString($hGraphics, $sText, $hFont, $tLayout, $hFormat)
	If $bCenter Then
		Local $iXPos = DllStructGetData($aInfo[0], 1)
		DllStructSetData($aInfo[0], 1, $iXPos - DllStructGetData($aInfo[0], 3) / 2)
	EndIf
	_GDIPlus_GraphicsDrawStringEx($hGraphics, $sText, $hFont, $aInfo[0], $hFormat, $hBrush)
	_GDIPlus_FontDispose($hFont)
	_GDIPlus_FontFamilyDispose($hFamily)
	_GDIPlus_StringFormatDispose($hFormat)
EndFunc   ;==>_DrawText



Func _CreateMeterBmp($hGraphics, $iW, $iH)
	Local $hBrush[6], $iTile = Ceiling($iH / 12)
	$hBrush[0] = _GDIPlus_BrushCreateSolid(0xFFFF0000)
	$hBrush[1] = _GDIPlus_LineBrushCreate(0, $iTile, 0, $iTile * 2, 0xFFFF0000, 0xFFFFFF00, 1)
	$hBrush[2] = _GDIPlus_BrushCreateSolid(0xFFFFFF00)
	$hBrush[3] = _GDIPlus_LineBrushCreate(0, $iTile * 3, 0, $iTile * 4, 0xFFFFFF00, 0xFF00FF00, 1)
	$hBrush[4] = _GDIPlus_BrushCreateSolid(0xFF00FF00)
	$hBrush[5] = _GDIPlus_LineBrushCreate(0, 0, 0, 4, 0x00000000, 0xAA000000)
	Local $hBitmap = _GDIPlus_BitmapCreateFromGraphics($iW, $iH, $hGraphics)
	Local $hContext = _GDIPlus_ImageGetGraphicsContext($hBitmap)
	_GDIPlus_GraphicsSetSmoothingMode($hContext,2)
	_GDIPlus_GraphicsFillRect($hContext, 0, 0, $iW, $iTile, $hBrush[0])
	_GDIPlus_GraphicsFillRect($hContext, 0, $iTile, $iW, $iTile, $hBrush[1])
	_GDIPlus_GraphicsFillRect($hContext, 0, $iTile * 2, $iW, $iTile, $hBrush[2])
	_GDIPlus_GraphicsFillRect($hContext, 0, $iTile * 3, $iW, $iTile, $hBrush[3])
	_GDIPlus_GraphicsFillRect($hContext, 0, $iTile * 4, $iW, $iTile * 8, $hBrush[4])
	For $i = 0 To $iH Step 4
		_GDIPlus_GraphicsFillRect($hContext, 0, $i, $iW, 4, $hBrush[5])
	Next
	_GDIPlus_GraphicsDispose($hContext)
	For $i = 0 To 5
		_GDIPlus_BrushDispose($hBrush[$i])
	Next
	Return $hBitmap
EndFunc   ;==>_CreateMeterBmp


Func _CreatePhaseBmp($hGraphics, $iW, $iH)
	Local $hBrush[5], $iTile = Ceiling($iW / 12)
	$hBrush[0] = _GDIPlus_BrushCreateSolid(0xFFFF0000)
	$hBrush[1] = _GDIPlus_LineBrushCreate($iTile * 5, 0, $iTile * 6, 0, 0xFFFF0000, 0xFFFFFF00, 1)
	$hBrush[2] = _GDIPlus_LineBrushCreate($iTile * 6, 0, $iTile * 7, 0, 0xFFFFFF00, 0xFF00FF00, 1)
	$hBrush[3] = _GDIPlus_BrushCreateSolid(0xFF00FF00)
	$hBrush[4] = _GDIPlus_LineBrushCreate(0, 0, 4, 0, 0x00000000, 0xAA000000)
	Local $hBitmap = _GDIPlus_BitmapCreateFromGraphics($iW, $iH, $hGraphics)
	Local $hContext = _GDIPlus_ImageGetGraphicsContext($hBitmap)
	_GDIPlus_GraphicsSetSmoothingMode($hContext,2)
	_GDIPlus_GraphicsFillRect($hContext, 0, 0, $iTile * 5, $iH, $hBrush[0])
	_GDIPlus_GraphicsFillRect($hContext, $iTile * 5, 0, $iTile, $iH, $hBrush[1])
	_GDIPlus_GraphicsFillRect($hContext, $iTile * 6, 0, $iTile, $iH, $hBrush[2])
	_GDIPlus_GraphicsFillRect($hContext, $iTile * 7, 0, $iTile * 5, $iH, $hBrush[3])
	For $i = 0 To $iW Step 4
		_GDIPlus_GraphicsFillRect($hContext, $i, 0, 4, $iH, $hBrush[4])
	Next
	_GDIPlus_GraphicsDispose($hContext)
	For $i = 0 To 4
		_GDIPlus_BrushDispose($hBrush[$i])
	Next
	Return $hBitmap
EndFunc   ;==>_CreatePhaseBmp



Func _CreateLedBmp($hGraphics, $iSize, $iOffColor, $iOnColor)
	Local $hBitmap = _GDIPlus_BitmapCreateFromGraphics($iSize, $iSize, $hGraphics)
	Local $hContext = _GDIPlus_ImageGetGraphicsContext($hBitmap)
	_GDIPlus_GraphicsSetSmoothingMode($hContext,2)
	Local $hPen = _GDIPlus_PenCreate()
	Local $hPath = _GDIPlus_CreatePath()
	_GDIPlus_AddPathEllipse($hPath, 0, 0, $iSize, $iSize)
	Local $hBrushGrad = _GDIPlus_CreatePathGradientFromPath($hPath)
	_GDIPlus_SetLineGammaCorrection($hBrushGrad, True)
	_GDIPlus_SetPathGradientSurroundColorsWithCount($hBrushGrad, $iOffColor)
	_GDIPlus_SetPathGradientCenterColor($hBrushGrad, $iOnColor)
	_GDIPlus_FillPath($hContext, $hBrushGrad, $hPath)
	_GDIPlus_ClosePathFigure($hPath)
	_GDIPlus_GraphicsDrawEllipse($hContext, 0, 0, $iSize, $iSize, $hPen)
	_GDIPlus_PenDispose($hPen)
	_GDIPlus_BrushDispose($hBrushGrad)
	_GDIPlus_PathDispose($hPath)
	_GDIPlus_GraphicsDispose($hContext)
	Return $hBitmap
EndFunc   ;==>_CreateLedBmp











Func _Exit()
	_BASS_StreamFree($hStream)
	___Debug(@error, "free stream")

	_BASS_Free()
	___Debug(@error, "free bass")

	_GDIPlus_BitmapDispose($hBmpLed)
	_GDIPlus_GraphicsDispose($hGfxBuffer)
	_GDIPlus_BitmapDispose($hBmpBuffer)
	_GDIPlus_BitmapDispose($hBmpMeter)
	_GDIPlus_BitmapDispose($hBmpBk)
	_GDIPlus_GraphicsDispose($hGraphics)
	_GDIPlus_Shutdown()
	Exit
EndFunc   ;==>_Exit





; #FUNCTION# ====================================================================================================================
; Name...........: _GDIPlus_LineBrushCreate
; Description ...: Creates a LinearGradientBrush object from a set of boundary points and boundary colors
; Syntax.........: _GDIPlus_LineBrushCreate($nX1, $nY1, $nX2, $nY2, $iARGBClr1, $iARGBClr2[, $iWrapMode = 0])
; Parameters ....: $nX1		  - X coordinate of the starting point of the gradient. The starting boundary line passes through the
;                  +starting point
;                  $nY1		  - Y coordinate of the starting point of the gradient. The starting boundary line passes through the
;                  +starting point
;                  $nX2		  - X coordinate of the ending point of the gradient. The ending boundary line passes through the
;                  +ending point
;                  $nY2		  - Y coordinate of the ending point of the gradient. The ending boundary line passes through the
;                  +ending point
;                  $iARGBClr1 - Alpha, Red, Green and Blue components of the starting color of the line
;                  $iARGBClr2 - Alpha, Red, Green and Blue components of the ending color of the line
;                  $iWrapMode - Wrap mode that specifies how areas filled with the brush are tiled:
;                  |0 - Tiling without flipping
;                  |1 - Tiles are flipped horizontally as you move from one tile to the next in a row
;                  |2 - Tiles are flipped vertically as you move from one tile to the next in a column
;                  |3 - Tiles are flipped horizontally as you move along a row and flipped vertically as you move along a column
;                  |4 - No tiling takes place
; Return values .: Success      - Pointer to a new LinearGradientBrush object
;                  Failure      - 0 and either:
;                  |@error and @extended are set if DllCall failed
;                  |$GDIP_STATUS contains a non zero value specifying the error code
; Remarks .......: After you are done with the object, call _GDIPlus_BrushDispose to release the object resources
; Related .......: _GDIPlus_BrushDispose
; Link ..........; @@MsdnLink@@ GdipCreateLineBrush
; Example .......; No
; ===============================================================================================================================
Func _GDIPlus_LineBrushCreate($nX1, $nY1, $nX2, $nY2, $iARGBClr1, $iARGBClr2, $iWrapMode = 0)
	Local $tPointF1, $pPointF1
	Local $tPointF2, $pPointF2
	Local $aResult

	$tPointF1 = DllStructCreate("float;float")
	$pPointF1 = DllStructGetPtr($tPointF1)
	$tPointF2 = DllStructCreate("float;float")
	$pPointF2 = DllStructGetPtr($tPointF2)

	DllStructSetData($tPointF1, 1, $nX1)
	DllStructSetData($tPointF1, 2, $nY1)
	DllStructSetData($tPointF2, 1, $nX2)
	DllStructSetData($tPointF2, 2, $nY2)

	$aResult = DllCall($ghGDIPDll, "uint", "GdipCreateLineBrush", "ptr", $pPointF1, "ptr", $pPointF2, "uint", $iARGBClr1, "uint", $iARGBClr2, "int", $iWrapMode, "int*", 0)

	If @error Then Return SetError(@error, @extended, 0)
	$GDIP_STATUS = $aResult[0]
	Return $aResult[6]
EndFunc   ;==>_GDIPlus_LineBrushCreate


Func _GDIPlus_CreatePath($brushMode = 0)
	Local $hPath
	$hPath = DllCall($ghGDIPDll, "int", "GdipCreatePath", "int", $brushMode, "handle*", 0)
	If @error Then Return SetError(1, @error, 0)
	Return SetError($hPath[0], 0, $hPath[2])
EndFunc   ;==>_GDIPlus_CreatePath

Func _GDIPlus_AddPathEllipse($hPath, $iX, $iY, $iWidth, $iHeight)
	Local $aResult = DllCall($ghGDIPDll, "int", "GdipAddPathEllipse", "handle", $hPath, "float", $iX, "float", $iY, "float", $iWidth, "float", $iHeight)
	If @error Then Return SetError(1, @error, 0)
	Return SetError($aResult[0], 0, $aResult[0] = 0)
EndFunc   ;==>_GDIPlus_AddPathEllipse

Func _GDIPlus_CreatePathGradientFromPath($hPath)
	Local $aResult = DllCall($ghGDIPDll, "int", "GdipCreatePathGradientFromPath", "handle", $hPath, "int*", 0)
	If @error Then Return SetError(1, @error, 0)
	Return SetError($aResult[0], 0, $aResult[2])
EndFunc   ;==>_GDIPlus_CreatePathGradientFromPath

Func _GDIPlus_SetLineGammaCorrection($hBrush, $useGammaCorrection = True)
	Local $aResult = DllCall($ghGDIPDll, "int", "GdipSetLineGammaCorrection", "handle", $hBrush, "int", $useGammaCorrection)
	If @error Then Return SetError(1, @error, 0)
	Return SetError($aResult[0], 0, $aResult[0] = 0)
EndFunc   ;==>_GDIPlus_SetLineGammaCorrection

Func _GDIPlus_SetPathGradientCenterColor($hBrush, $iARGB)
	Local $aResult = DllCall($ghGDIPDll, "int", "GdipSetPathGradientCenterColor", "handle", $hBrush, "int", $iARGB)
	If @error Then Return SetError(1, @error, 0)
	Return SetError($aResult[0], 0, $aResult[0] = 0)
EndFunc   ;==>_GDIPlus_SetPathGradientCenterColor

Func _GDIPlus_FillPath($hGraphic, $hBrushGrad, $hPath)
	Local $aResult = DllCall($ghGDIPDll, "int", "GdipFillPath", "handle", $hGraphic, "handle", $hBrushGrad, "handle", $hPath)
	If @error Then Return SetError(1, @error, 0)
	Return SetError($aResult[0], 0, $aResult[0] = 0)
EndFunc   ;==>_GDIPlus_FillPath

Func _GDIPlus_SetPathGradientSurroundColorsWithCount($hBrush, $aArgb)
	Local $iI, $iCount, $aResult, $res, $x, $pArgb
	If IsArray($aArgb) Then
		$iCount = UBound($aArgb)
		$tArgb = DllStructCreate("int[" & $iCount & "]")
		$pArgb = DllStructGetPtr($tArgb)
		For $iI = 0 To $iCount - 1
			DllStructSetData($tArgb, 1, $aArgb[$iI], $iI + 1)
		Next
	Else
		$iCount = 1
		$tArgb = DllStructCreate("int")
		$pArgb = DllStructGetPtr($tArgb)
		DllStructSetData($tArgb, 1, $aArgb, 1)
	EndIf
	$aResult = DllCall($ghGDIPDll, "int", "GdipSetPathGradientSurroundColorsWithCount", "handle", $hBrush, "int", $pArgb, "int*", $iCount)
	If @error Then Return SetError(1, @error, 0)
	Return SetError($aResult[0], $aResult[3], $aResult[0] = 0)
EndFunc   ;==>_GDIPlus_SetPathGradientSurroundColorsWithCount

Func _GDIPlus_ClosePathFigure($hPath)
	Local $aResult = DllCall($ghGDIPDll, "int", "GdipClosePathFigure", "handle", $hPath)
	If @error Then Return SetError(1, @error, 0)
	Return SetError($aResult[0], 0, $aResult[0] = 0)
EndFunc   ;==>_GDIPlus_ClosePathFigure

Func _GDIPlus_PathDispose($hPath)
	Local $aResult = DllCall($ghGDIPDll, "uint", "GdipDeletePath", "handle", $hPath)
	If @error Then Return SetError(1, @error, 0)
	Return SetError($aResult[0], 0, $aResult[0] = 0)
EndFunc   ;==>_GDIPlus_PathDispose



Func ___DeBug($iError, $sAction)
	Switch $iError
		Case -1
			ConsoleWrite(@CRLF & "-" & $sAction & @CRLF)
		Case 0
			ConsoleWrite(@CRLF & "+" & $sAction & " - OK" & @CRLF)
		Case Else
			ConsoleWrite(@CRLF & "!" & $sAction & " - FAILED" & @CRLF)
			Exit
	EndSwitch
EndFunc   ;==>___DeBug